#include <bits/stdc++.h>

#define IMPOSSIBLE (-2)
#define LIMITLESS (-1)

using namespace std;

typedef size_t node;

#ifdef EVAL
ifstream in("input.txt");
ofstream out("output.txt");
#else
istream &in(cin);
ostream &out(cout);
#endif

int main() {

    int N, E;
    in >> N >> E;

    node B = 0;
    node A = N - 1;

    vector<vector<node>> neighbours(N, vector<node>());
    for (; E; --E) {
        int a, b, c;
        in >> a >> b >> c;

        neighbours[a].push_back(b);
        neighbours[b].push_back(a);
    }

    vector<bool> is_mattel(N, false);
    int Z;
    in >> Z;
    for (; Z; --Z) {
        int m;
        in >> m;

        is_mattel[m] = true;
    }

    vector<node> parent(N, -1);
    priority_queue<tuple<int, bool, node>, vector<tuple<int, bool, node>>, std::greater<tuple<int, bool, node>>> min_q;
    parent[B] = B;
    min_q.emplace(0, true, B);

    for (; !min_q.empty(); min_q.pop()) {
        const int lv = get<0>(min_q.top());
        const bool is_free = get<1>(min_q.top());
        const node x = get<2>(min_q.top());
        for (const node adj: neighbours[x]) {
            if (parent[adj] != -1) continue;

            parent[adj] = x;
            min_q.emplace(lv + 1, is_free && !is_mattel[adj], adj);
        }
    }

    list<node> path;
    path.push_front(A);
    while (path.front() != B) {
        path.push_front(parent[path.front()]);
    }

    const long long K = any_of(path.cbegin(), path.cend(), [&is_mattel](const node x) { return is_mattel[x]; })
                        ? IMPOSSIBLE
                        : LIMITLESS;

    out << K << endl;
    out << path.size() << endl;
    for (const node x: path) {
        out << x << ' ';
    }
    out << endl;
    return 0;
}
