#include <bits/stdc++.h>

using namespace std;

#ifdef EVAL
    ifstream in("input.txt");
    ofstream out("output.txt");
#else
    istream &in(cin);
    ostream &out(cout);
#endif

void dijkstra(const vector<pair<int, int>> adj[], const int n, const int x, const int y, stack<int> &min_path) {
    vector<bool> visited(n, false);
    priority_queue<pair<long long, int>> pq;
    vector<long long> dist(n, LONG_LONG_MAX);
    vector<int> prec(n, -1);

    pq.push({0, x});
    dist[x] = 0;

    while (!pq.empty()) {
        auto act = pq.top();
        pq.pop();
        if (act.second == y) {
            visited[act.second] = true;
            break;
        } else if (!visited[act.second]) {
            visited[act.second] = true;
            for (int i = 0; i < adj[act.second].size(); i++) {
                if (dist[adj[act.second][i].first] > dist[act.second] + adj[act.second][i].second) {
                    dist[adj[act.second][i].first] = dist[act.second] + adj[act.second][i].second;
                    prec[adj[act.second][i].first] = act.second;
                    pq.push({-dist[adj[act.second][i].first], adj[act.second][i].first});
                }
            }
        }
    }
    if (visited[y]) {
        int act = y;
        while (act != -1) {
            min_path.push(act);
            act = prec[act];
        }
    } else {
        cout << "y non raggiungibile da x" << endl;
        exit(0);
    }
}

int main() {
    int n, p;
    in >> n >> p;
    int x=0, y=n-1;

    vector<pair<int, int>> adj[n];

    int a, b, c;
    for (int i = 0; i < p; i++) {
        in >> a >> b >> c;
        adj[a].push_back({b, c});
        adj[b].push_back({a, c});
    }

    int m;
    in >> m;
    vector<bool> matel(n, false);
    for (int i = 0; i < m; i++) {
        in >> a;
        matel[a] = true;
    }

    stack<int> min_path;
    dijkstra(adj, n, x, y, min_path);

    if (n == 2) out << -1 << endl;
    else{
        for (int i = 0; i < n; i++) {
            if (i != x && i != y) {
                if (!matel[i]) out << -1 << endl;
                else out << -2 << endl;
                break;
            }
        }
    }
    
    out << min_path.size() << endl;

    while (!min_path.empty()) {
        out << min_path.top() << " ";
        min_path.pop();
    }
    out << endl;

    return 0;
}